/* Autogenerated by ../bin/halcompile on Wed Mar  5 00:53:49 2025 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#include <unistd.h>
#include <rtapi_math.h>
#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:thermistor:compute temperature indicated by a thermistor");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "descr:This component computes the temperature indicated by a\nthermistor in a voltage-divider ladder.  It uses the Beta-parameter\nvariant of the Steinhart-Hart equation, described here:\n\n    http://en.wikipedia.org/wiki/Thermistor");
MODULE_INFO(linuxcnc, "pin:t0_c:float:0:in:Reference temperature of the thermistor, in degrees\nCelsius (typically 25 C).  This must be set before the component can\ncompute the thermistor temperature.  The reference temperature information\nis supplied by the thermistor manufacturer.:None:None");
MODULE_INFO(linuxcnc, "pin:r0:float:0:in:Resistance of the thermistor at the reference\ntemperature.  This must be set before the component can compute the\nthermistor temperature.  The reference resistance information is supplied\nby the thermistor manufacturer.:None:None");
MODULE_INFO(linuxcnc, "pin:beta:float:0:in:Beta parameter of the thermistor (sometimes\njust called B).  This must be set before the component can compute the\nthermistor temperature.  The Beta parameter is supplied by the thermistor\nmanufacturer.:None:None");
MODULE_INFO(linuxcnc, "pin:r_other:float:0:in:Resistance of the other resistor in the\nvoltage-divider ladder.  This must be set before the component can\ncompute the thermistor temperature.:None:None");
MODULE_INFO(linuxcnc, "pin:v_total:float:0:in:Supply voltage of the voltage-divider ladder.:None:None");
MODULE_INFO(linuxcnc, "pin:v_thermistor:float:0:in:Voltage drop across the termistor.:None:None");
MODULE_INFO(linuxcnc, "pin:temperature_c:float:0:out:Temperature sensed by the thermistor, in degrees Celsius.:None:None");
MODULE_INFO(linuxcnc, "pin:temperature_k:float:0:out:Temperature sensed by the thermistor, in Kelvins.:None:None");
MODULE_INFO(linuxcnc, "pin:temperature_f:float:0:out:Temperature sensed by the thermistor, in degrees Fahrenheit.:None:None");
MODULE_INFO(linuxcnc, "pin:resistance:float:0:out:Computed resistance of the thermistor.:None:None");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_float_t *t0_c_p;
    hal_float_t *r0_p;
    hal_float_t *beta_p;
    hal_float_t *r_other_p;
    hal_float_t *v_total_p;
    hal_float_t *v_thermistor_p;
    hal_float_t *temperature_c_p;
    hal_float_t *temperature_k_p;
    hal_float_t *temperature_f_p;
    hal_float_t *resistance_p;
};
#include <stdlib.h>
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    (void)extra_arg;
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = hal_pin_float_newf(HAL_IN, &(inst->t0_c_p), comp_id,
        "%s.t0-c", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->r0_p), comp_id,
        "%s.r0", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->beta_p), comp_id,
        "%s.beta", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->r_other_p), comp_id,
        "%s.r-other", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->v_total_p), comp_id,
        "%s.v-total", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->v_thermistor_p), comp_id,
        "%s.v-thermistor", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->temperature_c_p), comp_id,
        "%s.temperature-c", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->temperature_k_p), comp_id,
        "%s.temperature-k", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->temperature_f_p), comp_id,
        "%s.temperature-f", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->resistance_p), comp_id,
        "%s.resistance", prefix);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
char *names[16] = {0,};
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("thermistor");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "thermistor.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        int max_names = sizeof(names)/sizeof(names[0]);
        for(i=0; (i < max_names) && names[i]; i++) {
            if (strlen(names[i]) < 1) {
                rtapi_print_msg(RTAPI_MSG_ERR, "names[%d] is invalid (empty string)\n", i);
                r = -EINVAL;
                break;
            }
            r = export(names[i], i);
            if(r != 0) break;
       }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}
static void user_mainloop(void);
static void userinit(int argc, char **argv);

int __comp_parse_count(int *argc, char **argv) {
    int i;
    for (i = 0; i < *argc; i ++) {
        if (strncmp(argv[i], "count=", 6) == 0) {
            errno = 0;
            count = strtoul(&argv[i][6], NULL, 0);
            for (; i+1 < *argc; i ++) {
                argv[i] = argv[i+1];
            }
            argv[i] = NULL;
            (*argc)--;
            if (errno == 0) {
                return 1;
            }
        }
    }
    return 0;
}


int __comp_parse_names(int *argc, char **argv) {
    int i;
    for (i = 0; i < *argc; i ++) {
        if (strncmp(argv[i], "names=", 6) == 0) {
            char *p = &argv[i][6];
            int j;
            for (; i+1 < *argc; i ++) {
                argv[i] = argv[i+1];
            }
            argv[i] = NULL;
            (*argc)--;
            for (j = 0; j < 16; j ++) {
                names[j] = strtok(p, ",");
                p = NULL;
                if (names[j] == NULL) {
                    return 1;
                }
            }
            return 1;
        }
    }
    return 0;
}

int argc=0; char **argv=0;
int main(int argc_, char **argv_) {
    argc = argc_; argv = argv_;
    int found_count, found_names;
    found_count = __comp_parse_count(&argc, argv);
    found_names = __comp_parse_names(&argc, argv);
    if (found_count && found_names) {
        rtapi_print_msg(RTAPI_MSG_ERR, "count= and names= are mutually exclusive\n");
        return 1;
    }
    userinit(argc, argv);

    if(rtapi_app_main() < 0) return 1;
    user_mainloop();
    rtapi_app_exit();
    return 0;
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef t0_c
#undef t0_c_ptr
#define t0_c_ptr (__comp_inst->t0_c_p)
#define t0_c (0+*__comp_inst->t0_c_p)
#undef r0
#undef r0_ptr
#define r0_ptr (__comp_inst->r0_p)
#define r0 (0+*__comp_inst->r0_p)
#undef beta
#undef beta_ptr
#define beta_ptr (__comp_inst->beta_p)
#define beta (0+*__comp_inst->beta_p)
#undef r_other
#undef r_other_ptr
#define r_other_ptr (__comp_inst->r_other_p)
#define r_other (0+*__comp_inst->r_other_p)
#undef v_total
#undef v_total_ptr
#define v_total_ptr (__comp_inst->v_total_p)
#define v_total (0+*__comp_inst->v_total_p)
#undef v_thermistor
#undef v_thermistor_ptr
#define v_thermistor_ptr (__comp_inst->v_thermistor_p)
#define v_thermistor (0+*__comp_inst->v_thermistor_p)
#undef temperature_c
#undef temperature_c_ptr
#define temperature_c_ptr (__comp_inst->temperature_c_p)
#define temperature_c (*__comp_inst->temperature_c_p)
#undef temperature_k
#undef temperature_k_ptr
#define temperature_k_ptr (__comp_inst->temperature_k_p)
#define temperature_k (*__comp_inst->temperature_k_p)
#undef temperature_f
#undef temperature_f_ptr
#define temperature_f_ptr (__comp_inst->temperature_f_p)
#define temperature_f (*__comp_inst->temperature_f_p)
#undef resistance
#undef resistance_ptr
#define resistance_ptr (__comp_inst->resistance_p)
#define resistance (*__comp_inst->resistance_p)
#undef FOR_ALL_INSTS
#define FOR_ALL_INSTS() struct __comp_state *__comp_inst; for(__comp_inst = __comp_first_inst; __comp_inst; __comp_inst = __comp_inst->_next)


#line 64 "hal/user_comps/thermistor.comp"

#include <signal.h>

int should_exit = 0;

void sigterm_handler(int signo) {
    (void)signo;
    should_exit = 1;
}

static void userinit(int argc, char **argv) {
    (void)argc;
    (void)argv;
    signal(SIGTERM, sigterm_handler);
}

void user_mainloop(void) {
    while (!should_exit) {
        FOR_ALL_INSTS() {
            hal_float_t t0_k = t0_c + 273.15;
            hal_float_t r_inf;
            hal_float_t current;

            if (t0_k <= 0.0) {
                goto problem;
            }

            if (r_other <= 0.0) {
                goto problem;
            }

            r_inf = r0 * exp(-beta/t0_k);
            if (r_inf <= 0.0) {
                goto problem;
            }

            current = (v_total - v_thermistor) / r_other;
            if (current <= 0.0) {
                goto problem;
            }

            resistance = v_thermistor / current;
            if (isnan(resistance) || isinf(resistance) || (resistance <= 0.0)) {
                goto problem;
            }

            temperature_k = beta / log(resistance/r_inf);
            if (isnan(temperature_k) || isinf(temperature_k) || (temperature_k < 0.0)) {
                goto problem;
            }

            // no problems found
            goto ok;

problem:
            // override problematic output pins with bogus but not invalid values
            resistance = 0;
            temperature_k = 9999;

ok:
            temperature_c = temperature_k - 273.15;
            temperature_f = (temperature_c * 9.0 / 5.0) + 32.0;
        }
        usleep(100 * 1000);
    }
}

static int __comp_get_data_size(void) { return 0; }
